---
name: Feature request / 功能请求
about: Suggest an idea for this project
title: ''
labels: enhancement
assignees: alex-spataru

---

**Feature Request Template**

---

### **1. Is your feature request related to a problem? Please describe.**

> Example: "I’m frustrated when […]"

Provide a clear and concise description of the problem you’re facing:  
[Your answer here]

### **2. Describe the solution you’d like**

> Example: "I’d like the software to [...]"

Explain what you’d like to see happen:  
[Your answer here]

### **3. Describe alternatives you’ve considered**

> Example: "I’ve thought about using [...] instead."

List any alternative solutions or features you’ve considered:  
[Your answer here]

### **4. Additional context**

> Example: "Here’s a screenshot of the problem: [...]"

Include any other context, screenshots, or examples that might help explain your request:  
[Your answer here]

### **Important Notes**

- **Feature requests are treated with lower priority than bug fixes.**  
- **I am an open-source developer.** I provide this software as-is and cannot be responsible for long-term maintenance or personalized service. The source code is available freely, and if the issue is urgent, you’re encouraged to fix it yourself or hire someone (including myself) to do so.  
- If you urgently need a specific enhancement, you’re welcome to support the project by [donating at this link](https://www.paypal.com/donate?hosted_button_id=XN68J47QJKYDE). Donations help prioritize feature development.

Thank you for contributing to the improvement of this software!

---

### **对于中国用户 / For Chinese users, please delete this part if you speak English**

**1. 您的功能需求是否与某个问题有关？请描述。**  
> 示例: "当我 […] 时会感到很沮丧。"  
请清晰简洁地描述您遇到的问题:  
[请在这里填写您的答案]

**2. 描述您希望的解决方案**  
> 示例: "我希望软件能够 […]"  
解释您希望发生的情况:  
[请在这里填写您的答案]

**3. 描述您考虑过的替代方案**  
> 示例: "我考虑过使用 […] 作为替代方案。"  
列出您认为可以解决问题的任何其他替代解决方案或功能:  
[请在这里填写您的答案]

**4. 其他背景信息**  
> 示例: "以下是问题的截图 […]"  
包含任何其他背景信息、截图或示例，以帮助说明您的需求:  
[请在这里填写您的答案]

### 注意事项  
- **功能请求的优先级低于错误修复。**  
- **我是一个开源开发者。** 我提供此软件是“按原样”的，我无法负责长期维护或个性化服务。源代码是免费提供的，如果问题很紧急，建议您自己修复或雇佣他人（包括我）进行修复。  
- 如果您迫切需要某项增强功能，欢迎通过以下链接支持该项目: [捐赠链接](https://www.paypal.com/donate?hosted_button_id=XN68J47QJKYDE)。捐赠有助于优先开发功能。

感谢您为改进本软件做出的贡献！
